import { Util } from '../../lab/util/Util.js';
export class StringAdvance {
    constructor(sim) {
        this.sim_ = sim;
    }
    ;
    toString() {
        return this.toStringShort();
    }
    ;
    toStringShort() {
        return 'StringAdvance{sim_: ' + this.sim_.toStringShort() + '}';
    }
    ;
    advance(timeStep, opt_memoList) {
        const startTime = this.getTime();
        while (this.getTime() < startTime + timeStep) {
            this.sim_.advance();
        }
        this.sim_.getSimList().removeTemporary(this.sim_.getTime());
        this.sim_.modifyObjects();
        if (opt_memoList !== undefined) {
            opt_memoList.memorize();
        }
    }
    ;
    getTime() {
        return this.sim_.getTime();
    }
    ;
    getTimeStep() {
        return this.sim_.getTimeStep();
    }
    ;
    setTimeStep(value) {
        if (this.sim_.getTimeStep() != value) {
            this.sim_.setTimeStep(value);
        }
    }
    ;
    reset() {
        this.sim_.reset();
    }
    ;
    save() {
        this.sim_.saveInitialState();
    }
    ;
}
Util.defineGlobal('sims$pde$StringAdvance', StringAdvance);
