import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class CardioidPath extends AbstractPath {
    constructor(radius, start, finish, closedLoop, name, localName) {
        if (typeof start !== 'number') {
            start = -Math.PI;
        }
        if (typeof finish !== 'number') {
            finish = Math.PI;
        }
        if (closedLoop === undefined) {
            closedLoop = false;
        }
        name = name || CardioidPath.en.NAME;
        localName = localName || CardioidPath.i18n.NAME;
        super(name, localName, start, finish, closedLoop);
        this.a_ = radius;
    }
    ;
    toString() {
        return super.toString().slice(0, -1)
            + ', radius: ' + Util.NF(this.a_) + '}';
    }
    ;
    getClassName() {
        return 'CardioidPath';
    }
    ;
    x_func(t) {
        const c = Math.cos(t);
        return this.a_ * Math.sin(t) * (1 + c);
    }
    ;
    y_func(t) {
        const c = Math.cos(t);
        return -this.a_ * c * (1 + c);
    }
    ;
}
CardioidPath.en = {
    NAME: 'Cardioid'
};
CardioidPath.de_strings = {
    NAME: 'Cardioid'
};
CardioidPath.i18n = Util.LOCALE === 'de' ? CardioidPath.de_strings : CardioidPath.en;
Util.defineGlobal('sims$roller$CardioidPath', CardioidPath);
