import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class CirclePath extends AbstractPath {
    constructor(radius, start, finish, closedLoop, name, localName) {
        start = start ?? -3 * Math.PI / 2;
        finish = finish ?? Math.PI / 2;
        closedLoop = closedLoop ?? true;
        name = name || CirclePath.en.NAME;
        localName = localName || CirclePath.i18n.NAME;
        super(name, localName, start, finish, closedLoop);
        this.radius_ = radius;
    }
    ;
    toString() {
        return super.toString().slice(0, -1)
            + ', radius_: ' + Util.NF(this.radius_) + '}';
    }
    ;
    getClassName() {
        return 'CirclePath';
    }
    ;
    x_func(t) {
        return this.radius_ * Math.cos(t);
    }
    ;
    y_func(t) {
        return this.radius_ * Math.sin(t);
    }
    ;
}
CirclePath.en = {
    NAME: 'Circle'
};
CirclePath.de_strings = {
    NAME: 'Kreis'
};
CirclePath.i18n = Util.LOCALE === 'de' ? CirclePath.de_strings : CirclePath.en;
Util.defineGlobal('sims$roller$CirclePath', CirclePath);
