import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class LoopTheLoopPath extends AbstractPath {
    constructor(start, finish, name, localName) {
        if (typeof start !== 'number') {
            start = -3.7;
        }
        if (typeof finish !== 'number') {
            finish = 8.5;
        }
        name = name || LoopTheLoopPath.en.NAME;
        localName = localName || LoopTheLoopPath.i18n.NAME;
        super(name, localName, start, finish, false);
    }
    ;
    getClassName() {
        return 'LoopTheLoopPath';
    }
    ;
    x_func(t) {
        if (t < 0.5) {
            return t;
        }
        else if (t < 0.5 + LoopTheLoopPath.theta1 - LoopTheLoopPath.theta2) {
            return LoopTheLoopPath.radius * Math.cos(t - 0.5 + LoopTheLoopPath.theta2)
                + LoopTheLoopPath.xcenter;
        }
        else {
            return t - LoopTheLoopPath.theta1 + LoopTheLoopPath.theta2 - 1;
        }
    }
    ;
    y_func(t) {
        if (t < 0.5) {
            return (t + 1) * (t + 1) + LoopTheLoopPath.yoffset;
        }
        else if (t < 0.5 + LoopTheLoopPath.theta1 - LoopTheLoopPath.theta2) {
            return LoopTheLoopPath.radius * Math.sin(t - 0.5 + LoopTheLoopPath.theta2)
                + LoopTheLoopPath.ycenter + LoopTheLoopPath.yoffset;
        }
        else {
            const dd = t - LoopTheLoopPath.theta1 + LoopTheLoopPath.theta2 - 2;
            return dd * dd + LoopTheLoopPath.yoffset;
        }
    }
    ;
}
LoopTheLoopPath.theta1 = 3.46334;
LoopTheLoopPath.theta2 = -0.321751;
LoopTheLoopPath.radius = 0.527046;
LoopTheLoopPath.ycenter = 2.41667;
LoopTheLoopPath.xcenter = 0;
LoopTheLoopPath.yoffset = 1;
LoopTheLoopPath.en = {
    NAME: 'Loop'
};
LoopTheLoopPath.de_strings = {
    NAME: 'Schleife'
};
LoopTheLoopPath.i18n = Util.LOCALE === 'de' ? LoopTheLoopPath.de_strings : LoopTheLoopPath.en;
Util.defineGlobal('sims$roller$LoopTheLoopPath', LoopTheLoopPath);
