import { Util } from '../../lab/util/Util.js';
export class BlockCollision {
    constructor(leftBlock, rightBlock, time) {
        this.distance_ = NaN;
        this.mustHandle_ = false;
        this.targetGap_ = 0.005;
        this.accuracy_ = 0.005;
        this.impulse = NaN;
        this.leftBlock_ = leftBlock;
        this.rightBlock_ = rightBlock;
        this.detectedTime_ = time;
        this.updateCollision(time);
    }
    ;
    toString() {
        return 'BlockCollision{'
            + 'distance: ' + Util.NF5(this.distance_)
            + ', targetGap: ' + Util.NF5(this.targetGap_)
            + ', accuracy: ' + Util.NF5(this.accuracy_)
            + ', detectedTime: ' + Util.NF7(this.detectedTime_)
            + ', impulse: ' + Util.NF5(this.impulse)
            + ', mustHandle: ' + this.mustHandle_
            + ', leftBlock: ' + this.leftBlock_
            + ', rightBlock: ' + this.rightBlock_
            + '}';
    }
    ;
    bilateral() {
        return false;
    }
    ;
    closeEnough(allowTiny) {
        if (allowTiny) {
            return this.distance_ > 0 && this.distance_ < this.targetGap_ + this.accuracy_;
        }
        else {
            return Math.abs(this.distance_ - this.targetGap_) <= this.accuracy_;
        }
    }
    ;
    contact() {
        return false;
    }
    ;
    getDetectedTime() {
        return this.detectedTime_;
    }
    ;
    getDistance() {
        return this.distance_;
    }
    ;
    getEstimatedTime() {
        return NaN;
    }
    ;
    getImpulse() {
        return this.impulse;
    }
    ;
    getVelocity() {
        return this.rightBlock_.getVelocity().subtract(this.leftBlock_.getVelocity()).getX();
    }
    ;
    illegalState() {
        return this.distance_ < 0;
    }
    ;
    isColliding() {
        return this.distance_ < this.targetGap_ - this.accuracy_;
    }
    ;
    isTouching() {
        return this.distance_ < 2 * this.targetGap_;
    }
    ;
    needsHandling() {
        return this.mustHandle_;
    }
    ;
    setNeedsHandling(needsHandling) {
        this.mustHandle_ = needsHandling;
    }
    ;
    similarTo(c) {
        return c.leftBlock_ == this.leftBlock_ && c.rightBlock_ == this.rightBlock_;
    }
    ;
    updateCollision(_time) {
        this.distance_ = this.rightBlock_.getLeftWorld() - this.leftBlock_.getRightWorld();
    }
    ;
}
Util.defineGlobal('sims$springs$BlockCollision', BlockCollision);
