import { AutoScale } from "../../lab/graph/AutoScale.js";
import { ButtonControl } from "../../lab/controls/ButtonControl.js";
import { ChainOfSpringsSim } from './ChainOfSpringsSim.js';
import { CheckBoxControl } from '../../lab/controls/CheckBoxControl.js';
import { ChoiceControl } from '../../lab/controls/ChoiceControl.js';
import { CollideBlocksSim } from './CollideBlocksSim.js';
import { CollideSpringSim } from './CollideSpringSim.js';
import { CommonControls } from '../common/CommonControls.js';
import { DangleStickSim } from './DangleStickSim.js';
import { DisplayAxes } from '../../lab/graph/DisplayAxes.js';
import { DisplayClock } from '../../lab/view/DisplayClock.js';
import { DisplayShape } from '../../lab/view/DisplayShape.js';
import { DisplaySpring } from '../../lab/view/DisplaySpring.js';
import { DisplayText } from '../../lab/view/DisplayText.js';
import { Double2DSpringSim } from './Double2DSpringSim.js';
import { DoubleRect } from '../../lab/util/DoubleRect.js';
import { DoubleSpringSim } from './DoubleSpringSim.js';
import { EnergyBarGraph } from '../../lab/graph/EnergyBarGraph.js';
import { MoleculeSim } from './MoleculeSim.js';
import { NumericControl } from '../../lab/controls/NumericControl.js';
import { SimController } from '../../lab/app/SimController.js';
import { SimpleAdvance } from '../../lab/model/SimpleAdvance.js';
import { SimRunner } from '../../lab/app/SimRunner.js';
import { SimView } from '../../lab/view/SimView.js';
import { SingleSpringSim } from './SingleSpringSim.js';
import { Spring } from '../../lab/model/Spring.js';
import { SpringNonLinear1 } from './SpringNonLinear1.js';
import { SpringNonLinear2 } from './SpringNonLinear2.js';
import { Spring2DSim } from './Spring2DSim.js';
import { StandardGraph1 } from '../common/StandardGraph1.js';
import { Util } from '../../lab/util/Util.js';
import { VerticalLayout } from '../common/VerticalLayout.js';
export class TerminalSpringApp {
    constructor(elem_ids) {
        Util.setErrorHandler();
        this.layout = new VerticalLayout(elem_ids);
        this.terminal = this.layout.getTerminal();
    }
    ;
    defineNames(myName) {
        const t = this.terminal;
        t.addRegex('layout', myName + '.');
        t.addRegex('terminal|simCanvas', myName + '.layout.');
        t.addRegex('ChainOfSpringsSim|CollideBlocksSim|CollideSpringSim'
            + '|DangleStickSim|Double2DSpringSim|DoubleSpringSim|Molecule1Sim'
            + '|Molecule3Sim|SingleSpringSim|Spring2DSim|SpringNonLinear1'
            + '|SpringNonLinear2', 'sims$$springs$$', false);
        t.addRegex('CommonControls|StandardGraph1', 'sims$$common$$', false);
    }
    ;
    eval(script, output = true) {
        return this.terminal.eval(script, output);
    }
    ;
    static loadClass() {
        var f = AutoScale.toString;
        f = ButtonControl.toString;
        f = ChainOfSpringsSim.toString;
        f = CheckBoxControl.toString;
        f = ChoiceControl.toString;
        f = CollideBlocksSim.toString;
        f = CollideSpringSim.toString;
        f = DangleStickSim.toString;
        f = DisplayAxes.toString;
        f = DisplayClock.toString;
        f = DisplayShape.toString;
        f = DisplaySpring.toString;
        f = DisplayText.toString;
        f = DoubleRect.toString;
        f = Double2DSpringSim.toString;
        f = DoubleSpringSim.toString;
        f = EnergyBarGraph.toString;
        f = MoleculeSim.toString;
        f = NumericControl.toString;
        f = SimController.toString;
        f = SimpleAdvance.toString;
        f = SimRunner.toString;
        f = SimView.toString;
        f = SingleSpringSim.toString;
        f = Spring.toString;
        f = Spring2DSim.toString;
        f = StandardGraph1.toString;
        f = SpringNonLinear1.toString;
        f = SpringNonLinear2.toString;
        var p = CommonControls.makeAxes;
    }
    ;
}
Util.defineGlobal('sims$springs$TerminalSpringApp', TerminalSpringApp);
