import { Util } from "../lab/util/Util.js";
export class MockClock {
    constructor() {
        this.time_ms = 0;
        this.callbacks_ = [];
        this.nextID = 1001;
    }
    ;
    systemTime() {
        return this.time_ms / 1000;
    }
    ;
    cancelCallback(timeoutID) {
        let idx = this.callbacks_.findIndex((elem) => elem.id === timeoutID);
        if (idx >= 0) {
            this.callbacks_.splice(idx, 1);
            Util.assert(-1 === this.callbacks_.findIndex((elem) => elem.id === timeoutID));
        }
    }
    ;
    scheduleCallback(callback, delay_ms) {
        const my_id = this.nextID++;
        this.callbacks_.push({ fnc: callback,
            id: my_id,
            firetime_ms: this.time_ms + delay_ms
        });
        return my_id;
    }
    ;
    requestAnimFrame(callback) {
        return this.scheduleCallback(callback, 20);
    }
    ;
    cancelAnimFrame(requestID) {
        this.cancelCallback(requestID);
    }
    tick(advance_ms) {
        const finishTime = this.time_ms + advance_ms;
        let fired = [];
        while (this.time_ms < finishTime) {
            let nextTime = finishTime;
            this.callbacks_.forEach((cb) => {
                if (cb.firetime_ms <= nextTime && cb.firetime_ms > this.time_ms) {
                    nextTime = cb.firetime_ms;
                }
            }, this);
            Util.assert(nextTime - this.time_ms <= advance_ms);
            this.time_ms = nextTime;
            this.callbacks_.forEach((cb) => {
                if (cb.firetime_ms <= this.time_ms) {
                    cb.fnc();
                    fired.push(cb);
                }
            }, this);
            fired.forEach((cb) => { Util.remove(this.callbacks_, cb); }, this);
        }
    }
    ;
}
;
