import { ChoiceControl } from '../lab/controls/ChoiceControl.js';
import { CollisionAdvance } from '../lab/model/CollisionAdvance.js';
import { ContactSim } from '../lab/engine2D/ContactSim.js';
import { DoubleRect } from '../lab/util/DoubleRect.js';
import { Engine2DApp } from '../sims/engine2D/Engine2DApp.js';
import { LabelControl } from '../lab/controls/LabelControl.js';
import { RigidBodySim } from '../lab/engine2D/RigidBodySim.js';
import { SpeedTest } from './SpeedTest.js';
import { Util } from '../lab/util/Util.js';
export class SingleViewerApp extends Engine2DApp {
    constructor(elem_ids) {
        const simRect = new DoubleRect(-6, -6, 6, 6);
        const sim = new ContactSim();
        const advance = new CollisionAdvance(sim);
        super(elem_ids, simRect, sim, advance);
        SpeedTest.ball_vs_wall_setup(this.sim, advance);
        this.addPlaybackControls();
        this.addStandardControls();
        let ps = this.sim.getParameterString(RigidBodySim.en.COLLISION_HANDLING);
        this.addControl(new ChoiceControl(ps));
        ps = this.sim.getParameterString(RigidBodySim.en.EXTRA_ACCEL);
        this.addControl(new ChoiceControl(ps));
        if (Util.DEBUG) {
            this.addControl(new LabelControl('compiled ' + Util.COMPILE_TIME));
        }
        this.makeEasyScript();
        this.addURLScriptButton();
        this.graphSetup();
    }
    ;
    toString() {
        return this.toStringShort().slice(0, -1)
            + super.toString();
    }
    ;
    getClassName() {
        return 'SingleViewerApp';
    }
    ;
}
Util.defineGlobal('test$SingleViewerApp', SingleViewerApp);
